<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 1.1: Getting Started</title>
<link href="sx4.html" rev=precedes>
<link href="sx4b.html" rel=precedes>
<link href="sx4.html" rev=subdocument>
</head>
<body>
<H2>section 1.1: Getting Started</H2>

<p>page 6
</p><p>Deep sentence:
<blockquote>With these mechanical details mastered,
everything else is comparatively easy.
</blockquote>The claim that a program as simple as ``hello, world''
is a big hurdle
may seem outrageous,
but it's really quite true.
It <em>is</em> a hurdle:
on an unfamiliar computer,
it can be arbitrarily difficult to figure out how to enter a 
text file containing program source,
or how to compile and link it,
or how to invoke it,
or what happened after (if?) it ran.
The most experienced C programmers immediately go back to this 
one, simple program whenever they're trying out a new system
or a new way of entering or building programs
or a new way of printing output from within programs.
As they say,
everything else <em>is</em> comparatively easy.
</p><p>One hurdle which the authors don't mention but which many of 
you may find yourself facing is the choice of an appropriate 
compiler.
On many Unix machines, the <TT>cc</TT> command which the authors
describe is an older compiler which does not recognize modern,
ANSI Standard C syntax.
An old compiler will accept the simple program on page 6,
but it will not accept many of the other programs in the book.
If you find yourself getting baffling compilation errors on 
programs which you've typed in exactly as they're shown in the 
book, it probably indicates that you're using an older compiler.
On many machines, another compiler called
<TT>acc</TT> or
<TT>gcc</TT> is available,
and you'll want to use it, instead.
</p><p>Deep sentence:
<blockquote><TT>main</TT> will usually call other functions to help perform its job,
some that you wrote,
and others from libraries that are provided for you.
</blockquote>We heard about this already in the Introduction,
but here it is again:
as far as the compiler and the language definition are concerned,
there's no difference between a function that you write
and a function someone else wrote for you,
including a function like <TT>printf</TT>
which seems to be part of the language.
There's nothing magic about <TT>printf</TT>;
there's nothing that it can do that one of your functions couldn't.
(Well,
actually,
there are a few magic,
or at least surprising,
things about <TT>printf</TT>,
but they're magic in ways that your functions can be, too.)
</p><p>There is one slight problem with the simple ``hello, world''
program
in the book.
The problem
will usually be ignored
(that is, the program will usually work correctly),
but if you receive any warning or error messages
or have any problems having to do with
the ``value returned from <TT>main</TT>,''
jump forward to page 26
to learn why <TT>main</TT> ought to end with the line
<pre>	return 0;
</pre></p><hr>
<p>
Read sequentially:
<a href="sx4.html" rev=precedes>prev</a>
<a href="sx4b.html" rel=precedes>next</a>
<a href="sx4.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
